require 'singleton'

module BackgroundJobs
  def self.configure
    yield Configuration.instance

    strategy = BackgroundJobs.config.strategy

    case strategy
    when 'sidekiq'
      options = BackgroundJobs.config.strategy_options

      require 'background_jobs/strategies/sidekiq/setup'
      BackgroundJobs::Sidekiq.setup options
    end
  end

  def self.config
    Configuration.instance
  end

  class Configuration
    include Singleton

    attr_accessor :strategy, :strategy_options
  end
end
