require 'i18n'
require 'notification/notifier_service'
require 'notification/channel_name_service'

module BackgroundJobs
  module JobNotifier
    def error(job, exception)
      super(job, exception)

      notify_error(:message => I18n.t(:flash_background_error))
    end

    private

    def notify_error(data)
      notify('error', data)
    end

    def notify_success(data)
      notify('success', data)
    end

    def notify(event, data)
      Notification::NotifierService.notify(channel_name, event, data)
    end

    def channel_name
      @channel_name ||= Notification::ChannelNameService.private_channel_name(@id)
    end
  end
end