require 'background_jobs/job_id_generator'
require 'background_jobs/job_queue_factory'

module BackgroundJobs
  class QueueService
    include JobIdGenerator

    def self.enqueue(job_type, attributes = [], options = {})
      job_id = generate_job_id

      job_queue = JobQueueFactory.build
      job_queue.enqueue(job_type, job_id, attributes, options)

      job_id
    end
  end
end
