require 'sidekiq'
require 'background_jobs/job_factory'
require 'background_jobs/strategies/sidekiq/job_attributes_adapter'

module BackgroundJobs
  module Sidekiq
    class JobAdapter
      include ::Sidekiq::Worker

      def perform(*attrs)
        job_type = attrs.shift
        job_id = attrs.shift
        attrs = JobAttributesAdapter.new(attrs).decode

        job = JobFactory.build(job_type.to_sym, attrs)
        job.id = job_id.to_i
        job.execute
      end
    end
  end
end